<?php

// Attributes forms
if (isset($_POST['mondialrelay_code_client']) && $_POST['mondialrelay_code_client'] != '') {
    $mondialrelay_code_client = $_POST['mondialrelay_code_client'];
}
else {
    $mondialrelay_code_client = 'BDTEST13';
}
if (isset($_POST['mondialrelay_code_marque']) && $_POST['mondialrelay_code_marque'] != '') {
    $mondialrelay_code_marque = $_POST['mondialrelay_code_marque'];
}
else {
    $mondialrelay_code_marque = '11';
}
if (isset($_POST['mondialrelay_cle_privee']) && $_POST['mondialrelay_cle_privee'] != '') {
    $mondialrelay_cle_privee = $_POST['mondialrelay_cle_privee'];
}
else {
    $mondialrelay_cle_privee = 'PrivateK';
}
if (isset($_POST['mondialrelay_assurance']) && $_POST['mondialrelay_assurance'] != '') {
    $mondialrelay_assurance = $_POST['mondialrelay_assurance'];
}
else {
    $mondialrelay_assurance = '0';
}
if (isset($_POST['mondialrelay_nb_results']) && $_POST['mondialrelay_nb_results'] != '') {
    $mondialrelay_nb_results = $_POST['mondialrelay_nb_results'];
}
else {
    $mondialrelay_nb_results = '7';
}

// Save the attributes forms
$champs = array(
    'mondialrelay_code_client' => $mondialrelay_code_client,
    'mondialrelay_code_marque' => $mondialrelay_code_marque,
    'mondialrelay_cle_privee' => $mondialrelay_cle_privee,
    'mondialrelay_nb_results'        => $mondialrelay_nb_results,
    'mondialrelay_assurance' => $mondialrelay_assurance
);

// Labels of the general Mondial Relay attributes form
$labels_compte['mondialrelay_code_client']['label'] = __("Enseigne de production ou Code Enseigne pour l’offre START", 'mondialrelay-wordpress');
$labels_compte['mondialrelay_code_client']['description'] = __("Ce paramètre vous est transmis par votre référent commercial ou est disponible dans votre profil dans le cadre de l'Offre Start", 'mondialrelay-wordpress');
$labels_compte['mondialrelay_code_client']['type'] = "text";
$labels_compte['mondialrelay_code_marque']['label'] = __("Code Marque Mondial Relay", 'mondialrelay-wordpress');
$labels_compte['mondialrelay_code_marque']['description'] = __("Ce paramètre vous est transmis par votre référent commercial ou est disponible dans votre profil dans le cadre de l'Offre Start", 'mondialrelay-wordpress');
$labels_compte['mondialrelay_code_marque']['type'] = "text";
$labels_compte['mondialrelay_cle_privee']['label'] = __("Clé privée Mondial Relay", 'mondialrelay-wordpress');
$labels_compte['mondialrelay_cle_privee']['description'] = __("Ce paramètre vous est transmis par votre référent commercial ou est disponible dans votre profil dans le cadre de l'Offre Start", 'mondialrelay-wordpress');
$labels_compte['mondialrelay_cle_privee']['type'] = "text";

// Labels of the shipping Mondial Relay attributes form
$labels_livraison['mondialrelay_assurance']['label'] = __("Assurance", 'mondialrelay-wordpress');
$labels_livraison['mondialrelay_assurance']['description'] = __("Pour plus d’informations, contactez votre référent commercial Mondial Relay", 'mondialrelay-wordpress');
$labels_livraison['mondialrelay_assurance']['type'] = "select";
$labels_livraison['mondialrelay_assurance']['options'] = array(__('0 : Sans assurance', 'mondialrelay-wordpress') => 0, __('1 : Assurance complémentaire N1', 'mondialrelay-wordpress') => 1, __('2 : Assurance complémentaire N2', 'mondialrelay-wordpress') => 2, __('3 : Assurance complémentaire N3', 'mondialrelay-wordpress') => 3, __('4 : Assurance complémentaire N4', 'mondialrelay-wordpress') => 4, __('5 : Assurance complémentaire N5', 'mondialrelay-wordpress') => 5);

// Labels of the Mondial Relay points attributes form
$labels_points['mondialrelay_nb_results']['label'] = __("Nombre de Point Relais® à renvoyer", 'mondialrelay-wordpress');
$labels_points['mondialrelay_nb_results']['description'] = __("C’est le nombre de Points Relais qui seront proposés aux clients lors de la commande (entre 1 et 30)", 'mondialrelay-wordpress');
$labels_points['mondialrelay_nb_results']['type'] = "text";

// Update options
if (isset($_POST['submit'])) {
    $envoi = 1;
    $noty = 1;
    class_MRWP_db::update_options_champs($champs);
}

// Get the options
$champs = class_MRWP_db::get_options_champs($champs);

