<?php

 // Helpers of the plugin

class class_MRWP_helpers
{

// print of a var
    public static function varPrint($var) {
        echo '<pre>' . print_r($var, true) . '</pre>';
    }

// Expedition status
public static function etat_expedition($etat) {
    switch ($etat) {
        case '800':
            //return _x('Expédition créée', 'Order status', 'woocommerce');
            return __('Expédition créée', 'mondialrelay-wordpress');
            break;
        case '80':
            //return _x('Colis enregistré', 'Order status', 'woocommerce');
            return __('Colis enregistré', 'mondialrelay-wordpress');
            break;
        case '81':
            //return _x('Colis en traitement chez Mondial Relay', 'Order status', 'woocommerce');
            return __('Colis en traitement chez Mondial Relay', 'mondialrelay-wordpress');
            break;
        case '82':
            //return _x('Colis livré', 'Order status', 'woocommerce');
            return __('Colis livré', 'mondialrelay-wordpress');
            break;
        case '83':
            //return _x('Anomalie', 'Order status', 'woocommerce');
            return __('Anomalie', 'mondialrelay-wordpress');
            break;
    }
}

// Status code (error)
    public static function statut($callback) {
        switch ($callback) {
            case 1:
                return __("Enseigne invalide", 'mondialrelay-wordpress');
                break;
            case 2:
                return __("Numéro d'enseigne vide ou inexistant", 'mondialrelay-wordpress');
                break;
            case 3:
                return __("Numéro de compte enseigne invalide", 'mondialrelay-wordpress');
                break;
            case 5:
                return __("Numéro de dossier enseigne invalide", 'mondialrelay-wordpress');
                break;
            case 7:
                return __("Numéro de client enseigne invalide", 'mondialrelay-wordpress');
                break;
            case 8:
                return __("Mot de passe ou hashage invalide", 'mondialrelay-wordpress');
                break;
            case 9:
                return __("Ville non reconnu ou non unique", 'mondialrelay-wordpress');
                break;
            case 10:
                return __("Type de collecte invalide", 'mondialrelay-wordpress');
                break;
            case 11:
                return __("Numéro de Relais de Collecte invalide", 'mondialrelay-wordpress');
                break;
            case 12:
                return __("Pays de Relais de Collecte invalide", 'mondialrelay-wordpress');
                break;
            case 13:
                return __("Type de livraison invalide", 'mondialrelay-wordpress');
                break;
            case 14:
                return __("Numéro de Relais de livraison invalide", 'mondialrelay-wordpress');
                break;
            case 15:
                return __("Pays de Relais de livraison invalide", 'mondialrelay-wordpress');
                break;
            case 20:
                return __("Poids du colis invalide", 'mondialrelay-wordpress');
                break;
            case 21:
                return __("Taille (Longueur + Hauteur) du colis invalide", 'mondialrelay-wordpress');
                break;
            case 22:
                return __("Taille du colis invalide", 'mondialrelay-wordpress');
                break;
            case 24:
                return __("Numéro d'expédition ou de suivi invalide", 'mondialrelay-wordpress');
                break;
            case 26:
                return __("Temps de montage invalide", 'mondialrelay-wordpress');
                break;
            case 27:
                return __("Mode de collecte ou de livraison invalide", 'mondialrelay-wordpress');
                break;
            case 28:
                return __("Mode de collecte invalide", 'mondialrelay-wordpress');
                break;
            case 29:
                return __("Mode de livraison invalide", 'mondialrelay-wordpress');
                break;
            case 30:
                return __("Adresse (L1) invalide", 'mondialrelay-wordpress');
                break;
            case 31:
                return __("Adresse (L2) invalide", 'mondialrelay-wordpress');
                break;
            case 33:
                return __("Adresse (L3) invalide", 'mondialrelay-wordpress');
                break;
            case 34:
                return __("Adresse (L4) invalide", 'mondialrelay-wordpress');
                break;
            case 35:
                return __("Ville invalide", 'mondialrelay-wordpress');
                break;
            case 36:
                return __("Code postal invalide", 'mondialrelay-wordpress');
                break;
            case 37:
                return __("Pays invalide", 'mondialrelay-wordpress');
                break;
            case 38:
                return __("Numéro de téléphone invalide", 'mondialrelay-wordpress');
                break;
            case 39:
                return __("Adresse e-mail invalide", 'mondialrelay-wordpress');
                break;
            case 40:
                return __("Paramètres manquants", 'mondialrelay-wordpress');
                break;
            case 42:
                return __("Montant CRT invalide", 'mondialrelay-wordpress');
                break;
            case 43:
                return __("Devise CRT invalide", 'mondialrelay-wordpress');
                break;
            case 44:
                return __("Valeur du colis invalide", 'mondialrelay-wordpress');
                break;
            case 45:
                return __("Devise de la valeur du colis invalide", 'mondialrelay-wordpress');
                break;
            case 46:
                return __("Plage de numéro d'expédition épuisée", 'mondialrelay-wordpress');
                break;
            case 47:
                return __("Nombre de colis invalide", 'mondialrelay-wordpress');
                break;
            case 48:
                return __("Multi-Colis Relais interdit", 'mondialrelay-wordpress');
                break;
            case 49:
                return __("Action invalide", 'mondialrelay-wordpress');
                break;
            case 60:
                return __("Champ texte libre invalide (Ce code erreur n'est pas invalidant)", 'mondialrelay-wordpress');
                break;
            case 61:
                return __("Top avisage invalide", 'mondialrelay-wordpress');
                break;
            case 62:
                return __("Instruction de livraison invalide", 'mondialrelay-wordpress');
                break;
            case 63:
                return __("Assurance invalide", 'mondialrelay-wordpress');
                break;
            case 64:
                return __("Temps de montage invalide", 'mondialrelay-wordpress');
                break;
            case 65:
                return __("Top rendez-vous invalide", 'mondialrelay-wordpress');
                break;
            case 66:
                return __("Top reprise invalide", 'mondialrelay-wordpress');
                break;
            case 67:
                return __("Latitude invalide", 'mondialrelay-wordpress');
                break;
            case 68:
                return __("Longitude invalide", 'mondialrelay-wordpress');
                break;
            case 69:
                return __("Code Enseigne invalide", 'mondialrelay-wordpress');
                break;
            case 70:
                return __("Numéro de Point Relais® invalide", 'mondialrelay-wordpress');
                break;
            case 71:
                return __("Nature de point de vente non valide", 'mondialrelay-wordpress');
                break;
            case 74:
                return __("Langue invalide", 'mondialrelay-wordpress');
                break;
            case 78:
                return __("Pays de collecte invalide", 'mondialrelay-wordpress');
                break;
            case 79:
                return __("Pays de livraison invalide", 'mondialrelay-wordpress');
                break;
            case 80:
                return __("Code tracing : colis enregistré", 'mondialrelay-wordpress');
                break;
            case 81:
                return __("Code tracing : colis en traitement chez Mondial Relay", 'mondialrelay-wordpress');
                break;
            case 82:
                return __("Code tracing : colis livré", 'mondialrelay-wordpress');
                break;
            case 83:
                return __("Code tracing : anomalie", 'mondialrelay-wordpress');
                break;
            case 84:
                return __("(Réservé Code Tracing)", 'mondialrelay-wordpress');
                break;
            case 85:
                return __("(Réservé Code Tracing)", 'mondialrelay-wordpress');
                break;
            case 86:
                return __("(Réservé Code Tracing)", 'mondialrelay-wordpress');
                break;
            case 87:
                return __("(Réservé Code Tracing)", 'mondialrelay-wordpress');
                break;
            case 88:
                return __("(Réservé Code Tracing)", 'mondialrelay-wordpress');
                break;
            case 89:
                return __("(Réservé Code Tracing)", 'mondialrelay-wordpress');
                break;
            case 92:
                return __("Solde insuffisant (comptes prépayés)", 'mondialrelay-wordpress');
                break;
            case 93:
                return __("Aucun élément retourné par le plan de tri<br>Si vous effectuez une collecte ou une livraison en Point Relais®, vérifiez que les Point Relais® soient bien disponibles. Si vous effectuez une livraison à domicile, il est probable que le code postal que vous avez indiqué n'existe pas.", 'mondialrelay-wordpress');
                break;
            case 94:
                return __("Colis inexistant", 'mondialrelay-wordpress');
                break;
            case 95:
                return __("Compte Enseigne non activé", 'mondialrelay-wordpress');
                break;
            case 96:
                return __("Type d'enseigne incorrect en Base", 'mondialrelay-wordpress');
                break;
            case 97:
                return __("Clé de sécurité invalide", 'mondialrelay-wordpress');
                break;
            case 98:
                return __("Erreur générique (Paramètres invalides)<br>Cette erreur masque une autre erreur de la liste et ne peut se produire que dans le cas où le compte utlisé est en mode \"Production\"", 'mondialrelay-wordpress');
                break;
            case 99:
                return __("Erreur générique du service<br>Cette erreur peut être dû à un problème technique du service.<br> Veuillez notifier cette erreur à Mondial Relay en précisant la date et l'heure de la requête ainsi que les paramètres envoyés afin d'effectuer une vérification.", 'mondialrelay-wordpress');
                break;
            case 421:
                return __("Une expédition existe déjà pour cette commande", 'mondialrelay-wordpress');
                break;
            case 789:
                return __("Erreur réseau SOAP", 'mondialrelay-wordpress');
                break;
            default:
                return __("Aucune information disponible sur cette erreur", 'mondialrelay-wordpress');
                break;
        }
    }

// Tracking link according the country
    public static function lien_suivi($pays,$expeditionNum) {

        $mondialrelay_code_client = get_option( 'mondialrelay_code_client', 1 );
        $mondialrelay_code_marque = get_option( 'mondialrelay_code_marque', 1 );

         return '<a href="https://www.mondialrelay.com/public/permanent/tracking.aspx?ens='.$mondialrelay_code_client.$mondialrelay_code_marque.'&exp='.$expeditionNum.'&language='.$pays.'">Mondial Relay</a>';
    }

// Is the country authorized
    public static function is_pays_autorise($pays, $selection) {
        foreach ($pays as $p) {
            if ($selection == $p) {
                return 1;
            }
        }
        return 0;
    }

// Get the email shortcodes
    public static function shortcodes_email($order_id) {
        global $wpdb;
        $prefixe = $wpdb->prefix;

        $shortcodes =  class_MRWP_conf::get_shortcodes_email($order_id);
        $shortcodes['lien'] = self::lien_suivi($shortcodes['pays'],$shortcodes['expedition']);

        if ($shortcodes['pointrelais'] != '') {
            $shortcodes['adresse'] = $shortcodes['pointrelais'] . ' ' . $shortcodes['adresse1'] . ' ';
        } else {
            $shortcodes['adresse'] = $shortcodes['adresse1'] . ' ';
        }

        if ($shortcodes['adresse2'] != '') {
            $shortcodes['adresse'] .= $shortcodes['adresse2'] . ' ';
        }
        $shortcodes['adresse'] .= $shortcodes['cp'] . ' ' . $shortcodes['ville'];
        return $shortcodes;
    }

// Emails shortcodes parseur
    public static function parse_shortcodes($order_id, $texte) {
        $shortcodes = self::shortcodes_email($order_id);
        foreach ($shortcodes as $shortcode => $valeur) {
            $texte = str_replace('[' . $shortcode . ']', $valeur, $texte);
        }
        $texte = stripslashes($texte);
        return $texte;
    }

// Get the countries (2 numbers ISO Code)
    public static function get_pays() {
        $pays = array(
            __('France', 'mondialrelay-wordpress') => 'FR',
            __('Belgique', 'mondialrelay-wordpress') => 'BE',
            __('Luxembourg', 'mondialrelay-wordpress') => 'LU',
            __('Espagne', 'mondialrelay-wordpress') => 'ES',
            __('Allemagne', 'mondialrelay-wordpress') => 'DE',
            __('Autriche', 'mondialrelay-wordpress') => 'AT',
            __('Angleterre', 'mondialrelay-wordpress') => 'GB',
            __('Italie', 'mondialrelay-wordpress') => 'IT',
            __('Portugal', 'mondialrelay-wordpress') => 'PT',
            __('Pays-Bas', 'mondialrelay-wordpress') => 'NL'
        );
        return $pays;
    }

// Get the lang in accordance with the country (2 numbers ISO Code)
    public static function get_langue($pays) {
        switch ($pays) {
            case 'FR':
                return 'FR';
                break;
            // Mondial Relay Webservice doesn't recognize "BE" as a language
            case 'BE':
                return 'FR';
                break;
            case 'ES':
                return 'ES';
                break;
            case 'DE':
                return 'EN';
                break;
            case 'IT':
                return 'EN';
                break;
            // Mondial Relay Webservice doesn't recognize "LU" as a language
            case 'LU':
                return 'FR';
                break;
            case 'PT':
                return 'ES';
                break;
            case 'GB':
                return 'EN';
                break;
            case 'IE':
                return 'EN';
                break;
            case 'NL':
                return 'NL';
                break;
            case 'AT':
                return 'EN';
                break;
        }
        return 1;
    }

// Get WooCommerce shipping method name
    public static function get_shipping_method_name($shipping_method) {
        switch($shipping_method) {
            case 'flat_rate':
                return __("Forfait", 'mondialrelay-wordpress');
                break;

            case 'free_shipping':
                return __("Livraison gratuite", 'mondialrelay-wordpress');
                break;

            case 'local_pickup':
                return __("Point de vente", 'mondialrelay-wordpress');
                break;

            case 'mondialrelay_official_shipping':
                return __("Mondial Relay Officiel", 'mondialrelay-wordpress');
                break;

            case 'wbs':
                return __("Weight based Shipping", 'mondialrelay-wordpress');
                break;

            case 'jem_table_rate':
                return __("Table Rate Shipping (JEM)", 'mondialrelay-wordpress');
                break;

            case 'jem_table_rate_pro':
                return __("Table Rate Shipping Pro (JEM)", 'mondialrelay-wordpress');
                break;

            case 'flexible_shipping':
            case 'flexible_shipping_single':
                return __("Flexible Shipping", 'mondialrelay-wordpress');
                break;

            case 'betrs_shipping':
                return __("Table Rate Shipping (Bolder Elements)", 'mondialrelay-wordpress');
                break;

            case 'tree_table_rate':
                return __("Tree Table Rate", 'mondialrelay-wordpress');
                break;

            case 'table_rate':
                return __("Table Rate Shipping (WooCommerce)", 'mondialrelay-wordpress');
                break;

            case 'oik_weight_zone_shipping':
                return __("oik weight zone shipping", 'mondialrelay-wordpress');
                break;

            case 'oik_weight_zone_shipping':
                return __("oik weight zone shipping", 'mondialrelay-wordpress');
                break;

            case 'alg_wc_shipping':
                return __("Custom Shipping Methods", 'mondialrelay-wordpress');
                break;

            case 'ph_woocommerce_shipping_pro':
                return __("Table Rate Shipping (PluginHive)", 'mondialrelay-wordpress');
                break;

            default:
                return __("N/A", 'mondialrelay-wordpress');
                break;
        }
    }

// Get WooCommerce shipping zone name
    public static function get_shipping_zone_name($shipping_zone) {
        $shipping_zone_name = class_MRWP_db::get_shipping_zone($shipping_zone);
        switch($shipping_zone_name) {
            case '':
                return __("Reste du monde", 'mondialrelay-wordpress');
                break;

            default:
                return $shipping_zone_name;
                break;
        }
    }


// Phone number correction
    public static function phone_validation($pays,$phone_num) {

        $phone_number = '';

      	if ( ! empty( $phone_num ) ) {
            $phone_number = trim($phone_num);
            
            if ( strlen( $phone_number ) > 2 && substr( $phone_number, 0, 2 ) !== '00' && substr( $phone_number, 0, 1 ) !== '+' ) {

                switch ($pays) {
                    case 'FR':
                        if (substr( $phone_number, 0, 1 ) == '0') {
                            $phone_number = substr($phone_number,1);
                        }
                        $phone_number = '+33' . $phone_number;
                        break;

                    case 'BE':
                        if (substr( $phone_number, 0, 1 ) == '0') {
                            $phone_number = substr($phone_number,1);
                        }
                        $phone_number = '+32' . $phone_number;
                        break;

                    case 'ES':
                        $phone_number = '+34' . $phone_number;
                        break;

                    case 'DE':
                        $phone_number = '+49' . $phone_number;
                        break;

                    case 'IT':
                        $phone_number = '+39' . $phone_number;
                        break;
                    
                    case 'LU':
                        $phone_number = '+352' . $phone_number;
                        break;

                    case 'PT':
                        $phone_number = '+351' . $phone_number;
                        break;

                    case 'GB':
                        $phone_number = '+44' . $phone_number;
                        break;
                        
                    case 'IE':
                        if (substr( $phone_number, 0, 1 ) == '0') {
                            $phone_number = substr($phone_number,1);
                        }
                        $phone_number = '+353' . $phone_number;
                        break;

                    case 'NL':
                        if (substr( $phone_number, 0, 1 ) == '0') {
                            $phone_number = substr($phone_number,1);
                        }
                        $phone_number = '+31' . $phone_number;
                        break;

                    case 'AT':
                        $phone_number = '+43' . $phone_number;
                        break;
                }
            } 
		}    
        return $phone_number;
    }


}