<?php
    // COMPTE
    if (!isset($_GET['tab']) || $_GET['tab'] == 'compte') {
        require_once dirname(__FILE__) . '/MRWP-admin-compte-controller.php';
    }
    // CONFIGURATION
    elseif ($_GET['tab'] == 'configuration') {
         require_once dirname(__FILE__) . '/MRWP-admin-conf-controller.php';
    }
    // VENDEUR
    elseif ($_GET['tab'] == 'vendeur') {
        require_once dirname(__FILE__) . '/MRWP-admin-vendor-controller.php';
    }
    // EMAIL
    elseif ($_GET['tab'] == 'email') {
        require_once dirname(__FILE__) . '/MRWP-admin-email-controller.php';
    }

    // LICENCE
    elseif ($_GET['tab'] == 'licence') {
        require_once dirname(__FILE__) . '/MRWP-admin-licence-controller.php';
    }

    // Display the page
    ?>
    <div class="wrap">

        <h2 class="nav-tab-wrapper woo-nav-tab-wrapper">
            <a href="?page=wp-mondialrelay&amp;tab=compte" class="nav-tab <?php if (!isset($_GET['tab']) || $_GET['tab'] == 'compte') echo 'nav-tab-active'; ?>"><?php _e("Compte", 'mondialrelay-wordpress') ?></a>
            <a href="?page=wp-mondialrelay&amp;tab=configuration" class="nav-tab <?php if (isset($_GET['tab']) && $_GET['tab'] == 'configuration') echo 'nav-tab-active'; ?>"><?php _e("Configuration", 'mondialrelay-wordpress') ?></a>
            <a href="?page=wp-mondialrelay&amp;tab=vendeur" class="nav-tab <?php if (isset($_GET['tab']) && $_GET['tab'] == 'vendeur') echo 'nav-tab-active'; ?>"><?php _e("Vendeur", 'mondialrelay-wordpress') ?></a>
            <a href="?page=wp-mondialrelay&amp;tab=email" class="nav-tab <?php if (isset($_GET['tab']) && $_GET['tab'] == 'email') echo 'nav-tab-active'; ?>"><?php _e("Emails", 'mondialrelay-wordpress') ?></a>
            <a href="?page=wp-mondialrelay&amp;tab=licence" class="nav-tab <?php if (isset($_GET['tab']) && $_GET['tab'] == 'licence') echo 'nav-tab-active'; ?>"><?php _e("Licence du plugin", 'mondialrelay-wordpress') ?></a>
        </h2>
        <br>

        <?php
        // COMPTE
        if (!isset($_GET['tab']) || $_GET['tab'] == 'compte') {
            require_once dirname(__FILE__) . '/MRWP-admin-compte-view.php';
        }
        // CONFIGURATION
        elseif ($_GET['tab'] == 'configuration') {
            require_once dirname(__FILE__) . '/MRWP-admin-conf-view.php';
        }
        // VENDEUR
        elseif ($_GET['tab'] == 'vendeur') {
            require_once dirname(__FILE__) . '/MRWP-admin-vendor-view.php';
        }
        // EMAIL
        elseif ($_GET['tab'] == 'email') {
            require_once dirname(__FILE__) . '/MRWP-admin-email-view.php';
        }
        // LICENCE
        elseif ($_GET['tab'] == 'licence') {
            require_once dirname(__FILE__) . '/MRWP-admin-licence-view.php';
        }
        ?>

    </div>
